B = [0 0 0 0 0 0 0 0 1];
A = [1 -0.2];
Ts= 1;

plant = filt(B,A,Ts);

% wn = 0.25;
% damp = 0.8;
% 
% Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
%P=Sys_des.den{1};

P = conv(A,[1 -0.5]);
[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
T = R;

 
AS=conv(A,S);
BR=conv(B,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
Syb=filt(BR,P,Ts);
puls=[0.0025:0.001:pi/Ts];
[mag,phase]=bode(Syp,puls);
mag=mag(:);

subplot(2,1,2)


puls=puls;
z=exp(i*2*puls);
sys=filt(1,[1 -1],Ts);
[mag1,phase]=bode(sys,puls);
[mag1,phase]=bode(sys,puls);
mag1a=1-mag1;
mag1b=1+mag1;
puls_norm=puls*Ts/(2*pi);
index=find(mag1a>0);
mag1a=mag1a(:);
mag1b=mag1b(:);

plot(puls_norm,20*log10(mag),'k:','linewidth',2);

subplot(2,1,1)
[mag,phase]=bode(Syb,puls);
mag=mag(:);

plot(puls_norm,20*log10(mag1(:)),'k','linewidth',2);
hold on
plot(puls_norm,20*log10(mag),'k:','linewidth',2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 
P = conv(A,[1 -0.3]);
for i=1:7
    P=conv(P,[1 -0.1]);
end
[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);

 
AS=conv(A,S);
BR=conv(B,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
Syb=filt(BR,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);



subplot(2,1,2)
hold on
plot(puls_norm,20*log10(mag),'k','linewidth',1)

maximum=6*ones(length(puls),1);

delmarg_idx=find(maximum>=20*log10(mag1b));
modmarg_idx=find(maximum<=20*log10(mag1b));
plot(puls_norm(modmarg_idx),maximum(modmarg_idx),'k-.','linewidth',2)
plot(puls_norm(delmarg_idx),20*log10(mag1b(delmarg_idx)),'k--','linewidth',2)
plot(puls_norm(index),20*log10(mag1a(index)),'k--','linewidth',2)


title('b) Syp Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
%set(gca,'FontSize',10,'FontWeight','Bold');
% text(0.3,-3,'alfa = -0.1','FontSize',10,'FontWeight','Bold');
% text(0.3,-6,'alfa = -0.333','FontSize',10,'FontWeight','Bold');
% text(0.3,-9,'alfa = -0.3','FontSize',10,'FontWeight','Bold');
% text(0.3,-9,'Template for Delay margin = Ts','FontSize',10,'FontWeight','Bold');
axis([0 0.5 -25 7])
legend('pole = 0.5','pole_{1} = 0.3, pole_{2-8} = 0.1','Template for Modulus margin','Template for Delay margin = T_{s}',4)
grid on



subplot(2,1,1)
[mag,phase]=bode(Syb,puls);
mag=mag(:);

plot(puls_norm,20*log10(mag),'k','linewidth',1)


% P = conv(A,[1 -0.3]);
% [Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);
% 
% 
% R = Rp;
% S = conv(Sp,[1 -1]);
% 
%  
% AS=conv(A,S);
% BR=conv(B,R);
% P=AS+BR;
% 
% Syb=filt(BR,P,Ts);
% [mag,phase]=bode(Syb,puls);
% mag=mag(:);
% plot(puls_norm,20*log10(mag),'g','linewidth',2)


title('a) Syb Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
%set(gca,'FontSize',10,'FontWeight','Bold');
% text(0.3,-3,'alfa = -0.1','FontSize',10,'FontWeight','Bold');
% text(0.3,-6,'alfa = -0.333','FontSize',10,'FontWeight','Bold');
% text(0.3,-9,'alfa = -0.3','FontSize',10,'FontWeight','Bold');
% text(0.3,-9,'Template for Delay margin = Ts','FontSize',10,'FontWeight','Bold');
axis([0 0.5 -18 0])
legend('Template for Delay margin = T_{s}','pole = 0.5','pole_{1} = 0.3, pole_{2-8} = 0.1',3)
grid on
